#if !defined(_MSNLOGINCLIENT_H__)
#define _MSNLOGINCLIENT_H__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
#include "MsnUser.h" 
// CMsnLoginClient.h : header file
//

class CMsnSocket;
//class CMsnUser;
/////////////////////////////////////////////////////////////////////////////
// CMsnLoginClient command target

class CMsnLoginClient : public CObject
{

// Attributes
private:


public:
	 
 
	CString			m_strServerName;
	CString			m_strHostIPAddress;
	CString			m_strMyNickName;
	CMsnSocket*	m_pSocket;
	CMsnUser* m_MsnUser[1000];
	CString			m_strCurChannel; // can join into serveral channels

	CString			m_strClientMsg;

	CString			m_strRecvMsg;
	
	//hf_added:
	CStringList		m_strlstDisplay;


// Operations
public:
	int m_iXfrSbUserNo;
	int DoUserXfrSB(int iInUserNo);
	int DispUserPage( int iInUserNo);
	int DoUserInput(const  char *aInCmd,int iInUserNo);
	CString m_strNick;

	int DispMainPage();
	int DoLST(CString aIn);
	int m_iCountUser;
	
	
	int m_iLoginOk;
	int DoTimerPNG();
	int m_iBytesForCmd;
	CString m_strPassword;
	int DoMD5( char *aIn, char *aOut );
	int DoHTTPSAuthentication(char *alTmp3,char *alTmp4);
	void DoXFR();
	int m_iSendXh;
	CMsnLoginClient();           // protected constructor used by dynamic creation
 
	virtual ~CMsnLoginClient();
	void ParseRecvedStr(CString strMsg);
	void ParseInputCommandStr(CString strMsg);

	void Init();

	
	//1.Connection Registration
	//void DoPass();
	//void DoUser();
	//void DoServer();
	//void DoOper();
	//void DoQuit();
	//void DoSquit();

	//2.Channel operations
	//void DoPart();
	//void DoMode();
	//void DoTopic();
	//void DoInvite();
	//void DoKick();

	//3.Server queries and commands
	//void DoVersion();
	//void DoStats();
	//void DoLinks();
	//void DoTime();
	//void DoCinnect();
	//void DoTrace();
	//void DoAdmin();
	//void DoInfo();

	
	//4.Sending messages
	void DoPrivmsg(LPCSTR lpszWho,LPCSTR lpszMessage);
	//void DoNotice();
	
	//5.User-based queries
	//void DoQuery();
	//void DoWho();
	//void DoWhowas();
	
	//6.Miscellaneous messages
	//void DoKill();
	//void DoPing();
	//void DoError();
	
	
	//OPTIONAL MESSAGES
	//void DoAway();
	//void DoRehash();
	//void DoRestart();
	//void DoSummon();
	//void DoUsers();
	//void DoWallops();
	//void DoUserHost();
	//void DoIson();


private:
	BOOL ClientConnectSocket(LPCTSTR lpszHostname ,UINT nPort );


// Implementation
protected:
	//virtual ~CMsnLoginClient();

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(_MSNLOGINCLIENT_H__)
