// SimMsnMessengerView.h : interface of the CSimMsnMessengerView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SIMMSNMESSENGERVIEW_H__23E1C221_9C92_4334_8785_ABF012AD5737__INCLUDED_)
#define AFX_SIMMSNMESSENGERVIEW_H__23E1C221_9C92_4334_8785_ABF012AD5737__INCLUDED_

#include "SimMsnMessengerDoc.h"
#include "MsnLoginClient.h"


#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//class CSimMsnMessengerDoc;


class CSimMsnMessengerView : public CHtmlView
{
protected: // create from serialization only
	CSimMsnMessengerView();
	DECLARE_DYNCREATE(CSimMsnMessengerView)

// Attributes
public:
	CSimMsnMessengerDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSimMsnMessengerView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnBeforeNavigate2(LPCTSTR lpszURL, DWORD nFlags, LPCTSTR lpszTargetFrameName, CByteArray& baPostedData, LPCTSTR lpszHeaders, BOOL* pbCancel);
	virtual void OnNavigateComplete2(LPCTSTR strURL);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	int m_iClientDeleted[3];
	CString m_strUser;
	CString m_strPwd;
	CString m_strServer;
	int     m_iServerPort;
	int m_iClientType;  // 0=irc; 1=msn; 2=...
  
	CMsnLoginClient* m_pMsnLoginClient;
	virtual ~CSimMsnMessengerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	
	//{{AFX_MSG(CSimMsnMessengerView)
	afx_msg void OnConnect();
	afx_msg void OnLock();
	afx_msg void OnDisconnect();
	afx_msg void OnDispLog();
	afx_msg LRESULT OnMyMessage(WPARAM wParam, LPARAM lParam);
	afx_msg void OnTestFuns();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnDISPMainPage();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in SimMsnMessengerView.cpp
inline CSimMsnMessengerDoc* CSimMsnMessengerView::GetDocument()
   { return (CSimMsnMessengerDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SIMMSNMESSENGERVIEW_H__23E1C221_9C92_4334_8785_ABF012AD5737__INCLUDED_)
